<?php
namespace JHodges\GiteaBot;

class Issue extends GiteaRepoData{

  public function __construct(Repo $repo,$data){
    parent::__construct($repo,$data);
  }

  public function request($url, $type='GET', $postFields = null){
    return $this->getRepo()->request($url, $type, $postFields);
  }

  public function addLabel($label){
    $args=['labels'=>[$label->id]];
    return $this->request($this->url.'/labels','POST',$args);
  }

  public function removeLabel($label){
    $id=$label->id;
    return $this->request($this->url."/labels/$id",'DELETE');
  }

  public function addComment($body){
    $args=['body'=>$body];
    return $this->request($this->url.'/comments','POST',$args);
  }

  public function getComments(){
    return $this->request($this->url.'/comments','GET');
  }

  /*
  * this field is handled seperatly to the others! :/
  * https://github.com/go-gitea/gitea/issues/8179
  */
  public function setDueDate(\DateTime $date){
    $args=['due_date'=>$date->format('c')];
    return $this->request($this->url.'/deadline','POST',$args);
  }

  public function hasLabel($label){
    $id=$label->id;
    foreach($this->labels as $label){
      if($label->id==$id){
        return true;
      }
    }
    return false;
  }
}
